#include <SDL.h>
#include <SDL_image.h>
#include <SDL_gfxPrimitives.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>

#define MAXPEHELY 1500
#define MINSEB 1.2
#define MAXSEB 2.5
#define MAXSZEL 4


SDL_Surface *screen;


typedef struct Pehely {
    double x;
    double y;
    double s;
} Pehely;


Uint32 getpixel(SDL_Surface *surface, int x, int y) {
    Uint32 *p = (Uint32*) ((Uint8 *)surface->pixels + y * surface->pitch + x * sizeof(Uint32));
    return *p;
}

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel) {
    Uint32 *p = (Uint32*) ((Uint8 *)surface->pixels + y * surface->pitch + x * sizeof(Uint32));
    *p = pixel;
}


double randdouble(double min, double max) {
    return (double)rand()/RAND_MAX*(max-min)+min;
}


void ujpehely(Pehely *f) {
    f->x = rand()%(screen->w - 2)+1;
    f->y = 0;
    f->s = randdouble(MINSEB, MAXSEB);
}


void init(SDL_Surface **k) {
    SDL_Surface *kep;
    
    srand(time(NULL));

    SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
    kep = IMG_Load("karacsony.jpg");
    if (kep == NULL) {
        printf("Nem lehet megnyitni a fajlt");
        exit(0);
    }
    screen = SDL_SetVideoMode(kep->w, kep->h, 32, 0);
    *k = SDL_CreateRGBSurface(0, kep->w, kep->h, 32, 0, 0, 0, 0);
    SDL_BlitSurface(kep, NULL, *k, NULL);   /* sajat formatumra */
    SDL_FreeSurface(kep);
}


Uint32 idozit(Uint32 ms, void* param) {
    SDL_Event ev;
    ev.type = SDL_USEREVENT;
    SDL_PushEvent(&ev);
    return ms;   /* ujabb varakozas */
}


void mozgat(SDL_Surface *kep, Pehely pelyhek[], int *db) {
    static double szelirany = 0, szeliranycel = 0, szelint = 0;
    Uint32 feher = 0xFFFFFFFF, ho = 0xFEFEFEFF;
    int i;

    if (*db < MAXPEHELY) {
        const int add = 1;    /* az elejen milyen gyakran jelennek meg az új hopelyhek */

        *db += add;
        for (i = 0; i < add; i++)
            ujpehely(&pelyhek[*db - add + i]);
    }
    /* osszes feldolgozasa */
    for (i = 0; i < *db; i++) {
        /* torles */
        putpixel(screen, pelyhek[i].x, pelyhek[i].y, getpixel(kep, pelyhek[i].x, pelyhek[i].y));
        /* egyszerre tobb y sornyit ugrunk. emiatt neha nem marad a helyen egy-egy hopehely... */
        pelyhek[i].y += pelyhek[i].s;
        /* alul kimegy? ezt tutira ellenorizzuk. */
        if (pelyhek[i].y>= kep->h) {
            putpixel(screen, pelyhek[i].x, kep->h-1, feher);
            ujpehely(&pelyhek[i]);
        }
        else {
            /* nekiutkozik lefele? */
            if (getpixel(screen, pelyhek[i].x, pelyhek[i].y) == feher) {
                /* 1:100 hogy megakad - tornyosodik */
                if (rand()%100 == 0) {
                    putpixel(screen, pelyhek[i].x, pelyhek[i].y-1, feher);
                    ujpehely(&pelyhek[i]);
                } else {
                    /* gurul balra, ha lehet */
                    if (pelyhek[i].x>0 && getpixel(screen, pelyhek[i].x-1, pelyhek[i].y-1) != feher && getpixel(screen, pelyhek[i].x-1, pelyhek[i].y) != feher && rand()%10 != 0)
                        pelyhek[i].x--;
                    else
                    /* gurul jobbra, ha lehet */
                    if (pelyhek[i].x<kep->w-1 && getpixel(screen, pelyhek[i].x+1, pelyhek[i].y-1) != feher && getpixel(screen, pelyhek[i].x+1, pelyhek[i].y) != feher && rand()%10 != 0)
                        pelyhek[i].x++;
                    else {
                        putpixel(screen, pelyhek[i].x, pelyhek[i].y-1, feher);
                        ujpehely(&pelyhek[i]);
                    }
                }
            }
        }

        /* itt is kis valtozatossag: 20%, hogy nem mozdul semmilyen iranyban. */
        if (rand()%5 != 0) {
            double m = pelyhek[i].x;
            double irany = szelirany+randdouble(-1, 1); /* +-1gyel terunk el a szeliranytol */

            pelyhek[i].x += irany;
            if (pelyhek[i].x < 1)
                pelyhek[i].x += (kep->w-2);
            if (pelyhek[i].x > kep->w-1)
                pelyhek[i].x -= (kep->w-2);
            /* falra nem mozdul ra */
            if (getpixel(screen, pelyhek[i].x, pelyhek[i].y) == feher)
                pelyhek[i].x = m;
        }
        
        /* ujra kirajzol */
        putpixel(screen, pelyhek[i].x, pelyhek[i].y, ho);
    }
    SDL_Flip(screen);
    
    /* szelirany valtas, 1:100 hogy valtunk */
    if (rand()%100 == 0) {
        /* random iranyba valtozik */
        szelint += randdouble(-0.1, 0.1);

        if (szelint < -1)
            szelint = -1;
        if (szelint > 1)
            szelint = 1;
        szeliranycel = sqrt(fabs(szelint))*MAXSZEL;
        if (szelint < 0)
            szeliranycel *= -1;   /* hogy az elojel megmaradjon */
    }

    /* valtunk vagy nem, a konkret szeliranyt lassan kozelitjuk a megcelzott ertekhez */
    if (szeliranycel > szelirany)
        szelirany += 0.01;
    if (szeliranycel < szelirany)
        szelirany -= 0.01;
}


int main(int argc, char *argv[]) {
    SDL_Surface *kep;
    SDL_TimerID id;
    int kilep;
    Pehely pelyhek[MAXPEHELY];     /* elobb-utobb elerik a maximalis szamot, ezert siman tomb */
    int db;
    
    init(&kep);
    
    id = SDL_AddTimer(40, idozit, NULL);
    SDL_BlitSurface(kep, NULL, screen, NULL);
    kilep = 0;
    db = 0;
    while (!kilep) {
        SDL_Event ev;
        SDL_WaitEvent(&ev);
        
        switch (ev.type) {
            case SDL_USEREVENT:
                mozgat(kep, pelyhek, &db);
                break;
                
            case SDL_QUIT:
                kilep = 1;
                break;
        }
    }
    SDL_RemoveTimer(id);

    SDL_FreeSurface(kep);
    return 0;
}
